## percona-galera-3 3.8

=== SConstruct ===
###################################################################
#
# Copyright (C) 2010-2014 Codership Oy <info@codership.com>
#
# SCons build script to build galera libraries
#
# Script structure:
# - Help message
# - Default parameters
# - Read commandline options
# - Set up and configure default build environment
# - Set up and configure check unit test build environment
# - Run root SConscript with variant_dir
#
####################################################################

import os
import platform
import string

sysname = os.uname()[0].lower()
machine = platform.machine()
bits = platform.architecture()[0]
print 'Host: ' + sysname + ' ' + machine + ' ' + bits

x86 = 0
if bits == '32bit':
    x86 = 32
elif bits == '64bit':
    x86 = 64


#
# Print Help
#

Help('''
Build targets:  build tests check install all
Default target: all

Commandline Options:
    static_ssl=[0|1]    Build with static SSL
    with_ssl=path       Prefix for SSL
    debug=n             debug build with optimization level n
    build_dir=dir       build directory, default: '.'
    boost=[0|1]         disable or enable boost libraries
    boost_pool=[0|1]    use or not use boost pool allocator
    revno=XXXX          source code revision number
    bpostatic=path      a path to static libboost_program_options.a
    extra_sysroot=path  a path to extra development environment (Fink, Homebrew, MacPorts, MinGW)
''')
# bpostatic option added on Percona request

#
# Default params
#

build_target = 'all'

# Optimization level
opt_flags    = ' -g -O3 -DNDEBUG'

# Architecture (defaults to build host type)
compile_arch = ''
link_arch    = ''

with_ssl     = ''

# Build directory
build_dir    = ''


#
# Read commandline options
#

build_dir = ARGUMENTS.get('build_dir', '')
with_ssl = ARGUMENTS.get('with_ssl', '/usr/lib64')

# Debug/dbug flags
debug = ARGUMENTS.get('debug', -1)
dbug  = ARGUMENTS.get('dbug', False)

debug_lvl = int(debug)
if debug_lvl >= 0 and debug_lvl < 3:
    opt_flags = ' -g -O%d -fno-inline' % debug_lvl
    dbug = True
elif debug_lvl == 3:
    opt_flags = ' -g -O3'

if dbug:
    opt_flags = opt_flags + ' -DGU_DBUG_ON'


if x86 == 32:
    compile_arch = ' -m32 -march=i686'
    link_arch    = compile_arch
    if sysname == 'linux':
        link_arch = link_arch + ' -Wl,-melf_i386'
elif x86 == 64 and sysname != 'sunos':
    compile_arch = ' -m64'
    link_arch    = compile_arch
    if sysname == 'linux':
        link_arch = link_arch + ' -Wl,-melf_x86_64'
elif machine == 'ppc64':
    compile_arch = ' -mtune=native'
    link_arch    = ''
elif sysname == 'sunos':
    compile_arch = ' -mtune=native'
    link_arch    = ''
else:
    compile_arch = ''
    link_arch    = ''


boost      = int(ARGUMENTS.get('boost', 1))
boost_pool = int(ARGUMENTS.get('boost_pool', 0))
static_ssl = int(ARGUMENTS.get('static_ssl', 0))
ssl        = int(ARGUMENTS.get('ssl', 1))
tests      = int(ARGUMENTS.get('tests', 1))
strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 1))


GALERA_VER = ARGUMENTS.get('version', '3.8')
GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
# export to any module that might have use of those
Export('GALERA_VER', 'GALERA_REV')
print 'Signature: version: ' + GALERA_VER + ', revision: ' + GALERA_REV

LIBBOOST_PROGRAM_OPTIONS_A = ARGUMENTS.get('bpostatic', '')
LIBBOOST_SYSTEM_A = string.replace(LIBBOOST_PROGRAM_OPTIONS_A, 'boost_program_options', 'boost_system')

#
# Set up and export default build environment
#

env = Environment(ENV = {'PATH' : os.environ['PATH'], 'HOME' : os.environ['HOME']})

# Set up environment for ccache and distcc
#env['ENV']['HOME']          = os.environ['HOME']
#env['ENV']['DISTCC_HOSTS']  = os.environ['DISTCC_HOSTS']
#env['ENV']['CCACHE_PREFIX'] = os.environ['CCACHE_PREFIX']
if 'CCACHE_DIR' in os.environ:
    env['ENV']['CCACHE_DIR'] = os.environ['CCACHE_DIR']
if 'CCACHE_CPP2' in os.environ:
    env['ENV']['CCACHE_CPP2'] = os.environ['CCACHE_CPP2']

# Set CC and CXX compilers
cc = os.getenv('CC', 'default')
if cc != 'default':
    env.Replace(CC = cc)
cxx = os.getenv('CXX', 'default')
if cxx != 'default':
    env.Replace(CXX = cxx)
link = os.getenv('LINK', 'default')
if link != 'default':
    env.Replace(LINK = link)

# Initialize CPPFLAGS and LIBPATH from environment to get user preferences
env.Replace(CPPFLAGS = os.getenv('CPPFLAGS', ''))
env.Replace(LIBPATH = [os.getenv('LIBPATH', '')])

# Set -pthread flag explicitly to make sure that pthreads are
# enabled on all platforms.
env.Append(CPPFLAGS = ' -pthread')

# Freebsd ports are installed under /usr/local
if sysname == 'freebsd' or sysname == 'sunos':
    env.Append(LIBPATH  = ['/usr/local/lib'])
    env.Append(CPPFLAGS = ' -I/usr/local/include ')
if sysname == 'sunos':
   env.Replace(SHLINKFLAGS = '-shared ')

# Add paths is extra_sysroot argument was specified
extra_sysroot = ARGUMENTS.get('extra_sysroot', '')
if sysname == 'darwin' and extra_sysroot == '':
    # common developer environments and paths
    if os.system('which -s port') == 0 and os.path.isfile('/opt/local/bin/port'):
        extra_sysroot = '/opt/local'
    elif os.system('which -s brew') == 0 and os.path.isfile('/usr/local/bin/brew'):
        extra_sysroot = '/usr/local'
    elif os.system('which -s fink') == 0 and os.path.isfile('/sw/bin/fink'):
        extra_sysroot = '/sw'
if extra_sysroot != '':
    env.Append(LIBPATH = [extra_sysroot + '/lib'])
    env.Append(CPPFLAGS = ' -I' + extra_sysroot + '/include')

# print env.Dump()
#
# Set up build and link paths
#

# Include paths
env.Append(CPPPATH = Split('''#
                              #/asio
                              #/common
                              #/galerautils/src
                              #/gcomm/src
                              #/gcomm/src/gcomm
                              #/gcache/src
                              #/gcs/src
                              #/wsdb/src
                              #/galera/src
                           '''))

# Library paths
#env.Append(LIBPATH = Split('''#/galerautils/src
#                              #/gcomm/src
#                              #/gcs/src
#                              #/wsdb/src
#                              #/galera/src
#                           '''))

# Preprocessor flags
if sysname != 'sunos' and sysname != 'darwin' and sysname != 'freebsd':
    env.Append(CPPFLAGS = ' -D_XOPEN_SOURCE=600')
if sysname == 'sunos':
    env.Append(CPPFLAGS = ' -D__EXTENSIONS__')
env.Append(CPPFLAGS = ' -DHAVE_COMMON_H')

# Common C/CXX flags
# These should be kept minimal as they are appended after C/CXX specific flags
env.Replace(CCFLAGS = opt_flags + compile_arch +
                      ' -Wall -Wextra -Wno-unused-parameter')

# C-specific flags
env.Replace(CFLAGS = ' -std=c99 -fno-strict-aliasing -pipe')

# CXX-specific flags
# Note: not all 3rd-party libs like '-Wold-style-cast -Weffc++'
#       adding those after checks
env.Replace(CXXFLAGS = ' -Wno-long-long -Wno-deprecated -ansi')
if sysname != 'sunos':
    env.Append(CXXFLAGS = ' -pipe')


# Linker flags
# TODO: enable '-Wl,--warn-common -Wl,--fatal-warnings' after warnings from
# static linking have beed addressed
#
env.Append(LINKFLAGS = link_arch)

#
# Check required headers and libraries (autoconf functionality)
#

conf = Configure(env)

# System headers and libraries

if not conf.CheckLib('pthread'):
    print 'Error: pthread library not found'
    Exit(1)

# libatomic may be needed on some 32bit platforms (and 32bit userland PPC64)
# for 8 byte atomics but not generally required
if 0 == x86:
    conf.CheckLib('atomic')

if sysname != 'darwin':
    if not conf.CheckLib('rt'):
        print 'Error: rt library not found'
        Exit(1)

if sysname == 'freebsd':
    if not conf.CheckLib('execinfo'):
        print 'Error: execinfo library not found'
        Exit(1)

if sysname == 'sunos':
    if not conf.CheckLib('socket'):
        print 'Error: socket library not found'
        Exit(1)
    if not conf.CheckLib('crypto'):
        print 'Error: crypto library not found'
        Exit(1)
    if not conf.CheckLib('nsl'):
        print 'Error: nsl library not found'
        Exit(1)

if conf.CheckHeader('sys/epoll.h'):
    conf.env.Append(CPPFLAGS = ' -DGALERA_USE_GU_NETWORK')

if conf.CheckHeader('byteswap.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_BYTESWAP_H')

if conf.CheckHeader('endian.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_ENDIAN_H')
elif conf.CheckHeader('sys/endian.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_SYS_ENDIAN_H')
elif conf.CheckHeader('sys/byteorder.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_SYS_BYTEORDER_H')
elif sysname != 'darwin':
    print 'can\'t find byte order information'
    Exit(1)

# Additional C headers and libraries

# boost headers

if not conf.CheckCXXHeader('boost/shared_ptr.hpp'):
    print 'boost/shared_ptr.hpp not found or not usable'
    Exit(1)
conf.env.Append(CPPFLAGS = ' -DHAVE_BOOST_SHARED_PTR_HPP')

if conf.CheckCXXHeader('unordered_map'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_UNORDERED_MAP')
elif conf.CheckCXXHeader('tr1/unordered_map'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_TR1_UNORDERED_MAP')
else:
    if conf.CheckCXXHeader('boost/unordered_map.hpp'):
        conf.env.Append(CPPFLAGS = ' -DHAVE_BOOST_UNORDERED_MAP_HPP')
    else:
        print 'no unordered map header available'
        Exit(1)

# pool allocator
if boost == 1:
    # Default suffix for boost multi-threaded libraries
    if sysname == 'darwin':
        boost_library_suffix = '-mt'
    else:
        boost_library_suffix = ''
    if sysname == 'darwin' and extra_sysroot != '':
        boost_library_path = extra_sysroot + '/lib'
    else:
        boost_library_path = ''
    # Use nanosecond time precision
    conf.env.Append(CPPFLAGS = ' -DBOOST_DATE_TIME_POSIX_TIME_STD_CONFIG=1')
    # Common procedure to find boost static library
    boost_libpaths = [ boost_library_path, '/usr/local/lib', '/usr/local/lib64', '/usr/lib', '/usr/lib64' ]
    def check_boost_library(libBaseName, header, configuredLibPath, autoadd = 1):
        libName = libBaseName + boost_library_suffix
        if configuredLibPath != '' and not os.path.isfile(configuredLibPath):
            print "Error: file '%s' does not exist" % configuredLibPath
            Exit(1)
        if configuredLibPath == '':
           for libpath in boost_libpaths:
               libname = libpath + '/lib%s.a' % libName
               if os.path.isfile(libname):
                   configuredLibPath = libname
                   break
        if configuredLibPath != '':
            if not conf.CheckCXXHeader(header):
                print "Error: header '%s' does not exist" % header
                Exit (1)
            if autoadd:
                conf.env.Append(LIBS=File(configuredLibPath))
            else:
                return File(configuredLibPath)
        else:
            if not conf.CheckLibWithHeader(libs=[libName],
                                           header=header,
                                           language='CXX',
                                           autoadd=autoadd):
                print 'Error: library %s does not exist' % libName
                Exit (1)
            return [libName]
    # Required boost headers/libraries
    #
    if boost_pool == 1:
        if conf.CheckCXXHeader('boost/pool/pool_alloc.hpp'):
            print 'Using boost pool alloc'
            conf.env.Append(CPPFLAGS = ' -DGALERA_USE_BOOST_POOL_ALLOC=1')
            # due to a bug in boost >= 1.50 we need to link with boost_system
            # - should be a noop with no boost_pool.
            if sysname == 'darwin':
                if conf.CheckLib('boost_system' + boost_library_suffix):
                    conf.env.Append(LIBS=['boost_system' + boost_library_suffix])
            check_boost_library('boost_system',
                                'boost/system/error_code.hpp',
                                LIBBOOST_SYSTEM_A)
        else:

## percona-galera-3 3.8-3390

=== debian/changelog ===
percona-galera-3 (3.8-3390-0ubuntu6) xenial; urgency=medium

  * Add s390[x] arch to build_config
  * Check and link tests with subunit

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 09 Mar 2016 14:21:57 +0000

percona-galera-3 (3.8-3390-0ubuntu5) wily; urgency=medium

  * Fix build with GCC 5, build with -Wno-error=pedantic.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 29 Aug 2015 00:05:08 +0200

percona-galera-3 (3.8-3390-0ubuntu4) wily; urgency=medium

  * No-change rebuild using boost 1.58.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Aug 2015 12:55:11 +0000

percona-galera-3 (3.8-3390-0ubuntu3) vivid; urgency=medium

  * Ubuntu upload from Github VCS commit 0ce363a for unreleased Debian
    changes.

 -- Robie Basak <robie.basak@ubuntu.com>  Wed, 18 Mar 2015 15:56:44 +0000

percona-galera-3 (3.8-3390-1) UNRELEASED; urgency=medium

  [ George Ormond Lorch III ]
  * New upstream version.
  * Removed unnecessary line(S) from .lintian-overrides
  * d/p/fix_garbd_stop.patch: Addresses upstream issue where on package rm,
    an attempt is made to stop garbd even if it not running, resulting in an
    rm error.
  * d/p/fix_arm64_ftb.patch: Add in some architecture details for arm64 in
    chromium/build_config.h to allow basic compilation to proceed through
    macro tests.
  * d/p/fix_i386_ftb.patch: Fixed i386 builds attempting to use intrinsics
    for crc32. i386 should be using manual crc32 calculations and not
    non-existing instructions.

  [ James Page ]
  * Rename package inline with agreed package naming for Galera variants.
  * Bump debhelper compat level to 9.
  * Drop symlink for defaults file, no longer required.
  * Correct path to garb defaults file, refresh existing patches.
  * Enable support for systemd.

  [ Robie Basak ]
  * d/p/fix_non-intel_ftb.patch: fix FTBFS on non-Intel architectures.
  * d/p/gu_rand-struct-holes.patch: correctly initialise gu_rse_t struct
    (LP: #1430874).

 -- George Ormond Lorch III <george.lorch@percona.com>  Mon, 01 Dec 2014 14:35:23 -0700

percona-xtradb-cluster-galera-2.x (2.1-2) unstable; urgency=medium

  * d/p/detect-atomic.patch: Add check to determine whether -latomic is required
    for GCC atomic built-ins. 
  * d/control: Limit to linux based architectures.

 -- James Page <james.page@ubuntu.com>  Wed, 18 Jun 2014 17:41:14 +0100

percona-xtradb-cluster-galera-2.x (2.1-1) unstable; urgency=medium

  * New upstream release.
  * d/install,links: Install galera extension to /usr/lib/galera2,
    symlink to /usr/lib.

 -- James Page <jamespage@debian.org>  Mon, 19 May 2014 10:36:11 +0100

percona-xtradb-cluster-galera-2.x (2.0-1) unstable; urgency=low

  * Initial package (Closes: #734892).

 -- James Page <jamespage@debian.org>  Mon, 10 Feb 2014 13:25:49 +0200

=== debian/control ===
Source: percona-galera-3
Section: database
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Uploaders: George Ormond Lorch III <george.lorch@percona.com>,
           Alexey Bychko <alexey.bychko@percona.com>,
           Tomislav Plavcic <tomislav.plavcic@percona.com>
Build-Depends: check,
               debhelper (>= 9~),
               dh-systemd (>= 1.5),
               libboost-dev (>= 1.41),
               libboost-program-options-dev (>= 1.41),
               libssl-dev,
               scons (>= 2)
Standards-Version: 3.9.6
Homepage: http://www.percona.com/software/percona-xtradb-cluster
Vcs-Git: git://github.com/percona/galera.git
Vcs-Browser: http://github.com/percona/galera.git

Package: percona-galera-3
Architecture: any
Breaks: galera-3,
        percona-xtradb-cluster-galera-2.x,
        percona-xtradb-cluster-galera-3.x,
        percona-xtradb-cluster-garbd-2.x,
        percona-xtradb-cluster-garbd-3.x
Replaces: galera-3,
          percona-xtradb-cluster-galera-2.x,
          percona-xtradb-cluster-galera-3.x,
          percona-xtradb-cluster-garbd-2.x,
          percona-xtradb-cluster-garbd-3.x
Provides: galera-3, percona-xtradb-cluster-galera-25
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Galera replication framework for Percona XtraDB Cluster
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see http://launchpad.net/wsrep. For a description of Galera
 replication engine see http://galeracluster.com.
 .
 This package contains the Galera library/plugin for Percona XtraDB Cluster.

Package: percona-galera-arbitrator-3
Architecture: any
Conflicts: garbd-2, garbd2
Breaks: galera-arbitrator-3, 
        percona-xtradb-cluster-galera-2.x,
        percona-xtradb-cluster-garbd-2.x,
        percona-xtradb-cluster-garbd-3.x
Replaces: galera-arbitrator-3,
          percona-xtradb-cluster-galera-2.x,
          percona-xtradb-cluster-garbd-2.x,
          percona-xtradb-cluster-garbd-3.x
Provides: galera-arbitrator-3
Depends: netcat-openbsd, ${misc:Depends}, ${shlibs:Depends}
Description: Galera arbitrator daemon for Percona XtraDB Cluster
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see http://launchpad.net/wsrep. For a description of Galera
 replication engine see http://galeracluster.com.
 .
 This package contains the Galera arbitrator daemon (garbd) for
 Percona XtraDB Cluster.

Package: percona-galera-3-dbg
Architecture: any
Section: debug
Depends: percona-galera-3 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for percona-galera-3
 This package contains the debugging symbols for percona-galera-3.

Package: percona-galera-arbitrator-3-dbg
Architecture: any
Section: debug
Depends: percona-galera-arbitrator-3 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for percona-galera-arbitrator-3
 This package contains the debugging symbols for percona-galera-arbitrator-3.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# Parallel build support as adviced
# at https://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	SCONS_ARGS += -j $(NUMJOBS)
	# Don't use MAKEFLAGS as it has strange 'w' and '--jobserver-fds=3,4' by default
endif

# Add support for verbose builds
ifneq (,$(filter verbose,$(DEB_BUILD_OPTIONS)))
	SCONS_ARGS += VERBOSE=1
endif

# Run tests by default
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	SCONS_ARGS += tests=1
endif


override_dh_auto_build:
	@echo $(SCONS_ARGS)
	scons $(SCONS_ARGS)

override_dh_auto_clean:
	scons -c
	rm config.log

# Start earlier than MySQL which has value 19
override_dh_installinit-arch:
	dh_installinit --name=garb -- defaults 18 22

override_dh_strip:
	dh_strip -ppercona-galera-3 --dbg-package=percona-galera-3-dbg
	dh_strip -ppercona-galera-arbitrator-3 --dbg-package=percona-galera-arbitrator-3-dbg

%:
	dh $@  --with systemd

.PHONY: override_dh_strip override_dh_auto_build

## percona-galera-3 3.19

=== SConstruct ===
--- 
+++ 
@@ -1,8 +1,18 @@
 ###################################################################
 #
-# Copyright (C) 2010-2014 Codership Oy <info@codership.com>
+# Copyright (C) 2010-2015 Codership Oy <info@codership.com>
 #
 # SCons build script to build galera libraries
+#
+# How to control the build with environment variables:
+# Set CC       to specify C compiler
+# Set CXX      to specify C++ compiler
+# Set CPPFLAGS to add non-standard include paths and preprocessor macros
+# Set CCFLAGS  to *override* optimization and architecture-specific options
+# Set CFLAGS   to supply C compiler options
+# Set CXXFLAGS to supply C++ compiler options
+# Set LDFLAGS  to *override* linking flags
+# Set LIBPATH  to add non-standard linker paths
 #
 # Script structure:
 # - Help message
@@ -20,15 +30,15 @@
 
 sysname = os.uname()[0].lower()
 machine = platform.machine()
-bits = platform.architecture()[0]
+bits = ARGUMENTS.get('bits', platform.architecture()[0])
 print 'Host: ' + sysname + ' ' + machine + ' ' + bits
 
-x86 = 0
+x86 = any(arch in machine for arch in [ 'x86', 'amd64', 'i686', 'i386' ])
+
 if bits == '32bit':
-    x86 = 32
+    bits = 32
 elif bits == '64bit':
-    x86 = 64
-
+    bits = 64
 
 #
 # Print Help
@@ -48,6 +58,7 @@
     revno=XXXX          source code revision number
     bpostatic=path      a path to static libboost_program_options.a
     extra_sysroot=path  a path to extra development environment (Fink, Homebrew, MacPorts, MinGW)
+    bits=[32bit|64bit]
 ''')
 # bpostatic option added on Percona request
 
@@ -58,7 +69,7 @@
 build_target = 'all'
 
 # Optimization level
-opt_flags    = ' -g -O3 -DNDEBUG'
+opt_flags    = ' -g -O3 -fno-omit-frame-pointer -DNDEBUG'
 
 # Architecture (defaults to build host type)
 compile_arch = ''
@@ -86,32 +97,30 @@
     opt_flags = ' -g -O%d -fno-inline' % debug_lvl
     dbug = True
 elif debug_lvl == 3:
-    opt_flags = ' -g -O3'
+    opt_flags = ' -g -O3 -fno-omit-frame-pointer'
 
 if dbug:
     opt_flags = opt_flags + ' -DGU_DBUG_ON'
 
-
-if x86 == 32:
-    compile_arch = ' -m32 -march=i686'
-    link_arch    = compile_arch
-    if sysname == 'linux':
-        link_arch = link_arch + ' -Wl,-melf_i386'
-elif x86 == 64 and sysname != 'sunos':
-    compile_arch = ' -m64'
-    link_arch    = compile_arch
-    if sysname == 'linux':
-        link_arch = link_arch + ' -Wl,-melf_x86_64'
-elif machine == 'ppc64':
+if sysname == 'sunos':
     compile_arch = ' -mtune=native'
-    link_arch    = ''
-elif sysname == 'sunos':
-    compile_arch = ' -mtune=native'
-    link_arch    = ''
-else:
-    compile_arch = ''
-    link_arch    = ''
-
+elif x86:
+    if bits == 32:
+        if machine == 'x86_64':
+            compile_arch = ' -mx32'
+        else:
+            compile_arch = ' -m32 -march=i686'
+            if sysname == 'linux':
+                link_arch = ' -Wl,-melf_i386'
+    else:
+        compile_arch = ' -m64'
+        if sysname == 'linux':
+            link_arch = ' -Wl,-melf_x86_64'
+    link_arch = compile_arch + link_arch
+elif machine == 's390x':
+    compile_arch = ' -mzarch'
+    if bits == 32:
+        compile_arch += ' -m32'
 
 boost      = int(ARGUMENTS.get('boost', 1))
 boost_pool = int(ARGUMENTS.get('boost_pool', 0))
@@ -121,7 +130,7 @@
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 1))
 
 
-GALERA_VER = ARGUMENTS.get('version', '3.8')
+GALERA_VER = ARGUMENTS.get('version', '3.19')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 # export to any module that might have use of those
 Export('GALERA_VER', 'GALERA_REV')
@@ -158,16 +167,20 @@
 
 # Initialize CPPFLAGS and LIBPATH from environment to get user preferences
 env.Replace(CPPFLAGS = os.getenv('CPPFLAGS', ''))
+env.Replace(CCFLAGS = os.getenv('CCFLAGS', ''))
+env.Replace(CFLAGS = os.getenv('CFLAGS', ''))
+env.Replace(CXXFLAGS = os.getenv('CXXFLAGS', ''))
+env.Replace(LINKFLAGS = os.getenv('LDFLAGS', ''))
 env.Replace(LIBPATH = [os.getenv('LIBPATH', '')])
 
 # Set -pthread flag explicitly to make sure that pthreads are
 # enabled on all platforms.
-env.Append(CPPFLAGS = ' -pthread')
+env.Append(CCFLAGS = ' -pthread')
 
 # Freebsd ports are installed under /usr/local
 if sysname == 'freebsd' or sysname == 'sunos':
     env.Append(LIBPATH  = ['/usr/local/lib'])
-    env.Append(CPPFLAGS = ' -I/usr/local/include ')
+    env.Append(CCFLAGS = ' -I/usr/local/include ')
 if sysname == 'sunos':
    env.Replace(SHLINKFLAGS = '-shared ')
 
@@ -183,33 +196,9 @@
         extra_sysroot = '/sw'
 if extra_sysroot != '':
     env.Append(LIBPATH = [extra_sysroot + '/lib'])
-    env.Append(CPPFLAGS = ' -I' + extra_sysroot + '/include')
+    env.Append(CCFLAGS = ' -I' + extra_sysroot + '/include')
 
 # print env.Dump()
-#
-# Set up build and link paths
-#
-
-# Include paths
-env.Append(CPPPATH = Split('''#
-                              #/asio
-                              #/common
-                              #/galerautils/src
-                              #/gcomm/src
-                              #/gcomm/src/gcomm
-                              #/gcache/src
-                              #/gcs/src
-                              #/wsdb/src
-                              #/galera/src
-                           '''))
-
-# Library paths
-#env.Append(LIBPATH = Split('''#/galerautils/src
-#                              #/gcomm/src
-#                              #/gcs/src
-#                              #/wsdb/src
-#                              #/galera/src
-#                           '''))
 
 # Preprocessor flags
 if sysname != 'sunos' and sysname != 'darwin' and sysname != 'freebsd':
@@ -220,31 +209,58 @@
 
 # Common C/CXX flags
 # These should be kept minimal as they are appended after C/CXX specific flags
-env.Replace(CCFLAGS = opt_flags + compile_arch +
+env.Append(CCFLAGS = opt_flags + compile_arch +
                       ' -Wall -Wextra -Wno-unused-parameter')
 
 # C-specific flags
-env.Replace(CFLAGS = ' -std=c99 -fno-strict-aliasing -pipe')
+env.Append(CFLAGS = ' -std=c99 -fno-strict-aliasing -pipe')
 
 # CXX-specific flags
 # Note: not all 3rd-party libs like '-Wold-style-cast -Weffc++'
 #       adding those after checks
-env.Replace(CXXFLAGS = ' -Wno-long-long -Wno-deprecated -ansi')
+env.Append(CXXFLAGS = ' -Wno-long-long -Wno-deprecated -ansi')
 if sysname != 'sunos':
     env.Append(CXXFLAGS = ' -pipe')
 
 
 # Linker flags
-# TODO: enable '-Wl,--warn-common -Wl,--fatal-warnings' after warnings from
+# TODO: enable ' -Wl,--warn-common -Wl,--fatal-warnings' after warnings from
 # static linking have beed addressed
 #
-env.Append(LINKFLAGS = link_arch)
+#env.Append(LINKFLAGS = ' -Wl,--warn-common -Wl,--fatal-warnings')
 
 #
 # Check required headers and libraries (autoconf functionality)
 #
 
-conf = Configure(env)
+#
+# Custom tests:
+#
+
+def CheckSystemASIOVersion(context):
+    system_asio_test_source_file = """
+#include <asio.hpp>
+
+#if ASIO_VERSION < 101001
+#error "Included asio version is too old"
+#endif
+
+int main()
+{
+    return 0;
+}
+
+"""
+    context.Message('Checking ASIO version (> 1.10.1) ... ')
+    result = context.TryLink(system_asio_test_source_file, '.cpp')
+    context.Result(result)
+    return result
+
+
+#
+# Construct confuration context
+#
+conf = Configure(env, custom_tests = {'CheckSystemASIOVersion': CheckSystemASIOVersion})
 
 # System headers and libraries
 
@@ -254,7 +270,7 @@
 
 # libatomic may be needed on some 32bit platforms (and 32bit userland PPC64)
 # for 8 byte atomics but not generally required
-if 0 == x86:
+if not x86:
     conf.CheckLib('atomic')
 
 if sysname != 'darwin':
@@ -294,6 +310,9 @@
     print 'can\'t find byte order information'
     Exit(1)
 
+if conf.CheckHeader('execinfo.h'):
+    conf.env.Append(CPPFLAGS = ' -DHAVE_EXECINFO_H')
+
 # Additional C headers and libraries
 
 # boost headers
@@ -327,8 +346,13 @@
         boost_library_path = ''
     # Use nanosecond time precision
     conf.env.Append(CPPFLAGS = ' -DBOOST_DATE_TIME_POSIX_TIME_STD_CONFIG=1')
+
     # Common procedure to find boost static library
-    boost_libpaths = [ boost_library_path, '/usr/local/lib', '/usr/local/lib64', '/usr/lib', '/usr/lib64' ]
+    if bits == 64:
+        boost_libpaths = [ boost_library_path, '/usr/lib64', '/usr/local/lib64' ]
+    else:
+        boost_libpaths = [ boost_library_path, '/usr/local/lib', '/usr/lib' ]
+
     def check_boost_library(libBaseName, header, configuredLibPath, autoadd = 1):
         libName = libBaseName + boost_library_suffix
         if configuredLibPath != '' and not os.path.isfile(configuredLibPath):
@@ -356,18 +380,4 @@
                 print 'Error: library %s does not exist' % libName
                 Exit (1)
             return [libName]
-    # Required boost headers/libraries
-    #
-    if boost_pool == 1:
-        if conf.CheckCXXHeader('boost/pool/pool_alloc.hpp'):
-            print 'Using boost pool alloc'
-            conf.env.Append(CPPFLAGS = ' -DGALERA_USE_BOOST_POOL_ALLOC=1')
-            # due to a bug in boost >= 1.50 we need to link with boost_system
-            # - should be a noop with no boost_pool.
-            if sysname == 'darwin':
-                if conf.CheckLib('boost_system' + boost_library_suffix):
-                    conf.env.Append(LIBS=['boost_system' + boost_library_suffix])
-            check_boost_library('boost_system',
-                                'boost/system/error_code.hpp',
-                                LIBBOOST_SYSTEM_A)
-        else:
+

=== debian/changelog ===
percona-galera-3 (3.19-0ubuntu1) zesty; urgency=medium

  * SECURITY UPDATE: Update to 3.19 to support security updates
    for percona-xtradb-server-5.6 (LP: #1668934).
  * Changes for new upstream release:
    - d/p/add-lsb-begin.patch,fix_arm64_ftb.patch,fix_s390x_ftb.patch,
      gcc6.patch: Dropped, no longer required or included upstream.
    - d/p/*: Refresh.
    - d/control: Add BD on libasio-dev.

 -- James Page <james.page@ubuntu.com>  Mon, 06 Mar 2017 09:46:27 +0000

percona-galera-3 (3.8-3390-0ubuntu11) zesty; urgency=medium

  * debian/patches/fix-unaligned-checksum.patch: avoid unaligned access.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 20 Feb 2017 16:59:00 -0800

percona-galera-3 (3.8-3390-0ubuntu10) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:36:46 +0000

percona-galera-3 (3.8-3390-0ubuntu9) yakkety; urgency=medium

  * Fix ftbfs with gcc-6.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 24 Aug 2016 03:05:52 +0100

percona-galera-3 (3.8-3390-0ubuntu8) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:29:00 +0000

percona-galera-3 (3.8-3390-0ubuntu7) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 23 Apr 2016 18:47:26 +0000

## percona-galera-3 3.21

=== SConstruct ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ###################################################################
 #
-# Copyright (C) 2010-2015 Codership Oy <info@codership.com>
+# Copyright (C) 2010-2016 Codership Oy <info@codership.com>
 #
 # SCons build script to build galera libraries
 #
@@ -13,6 +13,7 @@
 # Set CXXFLAGS to supply C++ compiler options
 # Set LDFLAGS  to *override* linking flags
 # Set LIBPATH  to add non-standard linker paths
+# Set RPATH    to add rpaths
 #
 # Script structure:
 # - Help message
@@ -27,13 +28,14 @@
 import os
 import platform
 import string
+import subprocess
 
 sysname = os.uname()[0].lower()
 machine = platform.machine()
 bits = ARGUMENTS.get('bits', platform.architecture()[0])
 print 'Host: ' + sysname + ' ' + machine + ' ' + bits
 
-x86 = any(arch in machine for arch in [ 'x86', 'amd64', 'i686', 'i386' ])
+x86 = any(arch in machine for arch in [ 'x86', 'amd64', 'i686', 'i386', 'i86pc' ])
 
 if bits == '32bit':
     bits = 32
@@ -54,6 +56,7 @@
     debug=n             debug build with optimization level n
     build_dir=dir       build directory, default: '.'
     boost=[0|1]         disable or enable boost libraries
+    system_asio=[0|1]   use system asio library, if available
     boost_pool=[0|1]    use or not use boost pool allocator
     revno=XXXX          source code revision number
     bpostatic=path      a path to static libboost_program_options.a
@@ -125,12 +128,14 @@
 boost      = int(ARGUMENTS.get('boost', 1))
 boost_pool = int(ARGUMENTS.get('boost_pool', 0))
 static_ssl = int(ARGUMENTS.get('static_ssl', 0))
+system_asio= int(ARGUMENTS.get('system_asio', 1))
 ssl        = int(ARGUMENTS.get('ssl', 1))
 tests      = int(ARGUMENTS.get('tests', 1))
+deterministic_tests = int(ARGUMENTS.get('deterministic_tests', 0))
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 1))
 
 
-GALERA_VER = ARGUMENTS.get('version', '3.19')
+GALERA_VER = ARGUMENTS.get('version', '3.21')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 # export to any module that might have use of those
 Export('GALERA_VER', 'GALERA_REV')
@@ -166,21 +171,22 @@
     env.Replace(LINK = link)
 
 # Initialize CPPFLAGS and LIBPATH from environment to get user preferences
-env.Replace(CPPFLAGS = os.getenv('CPPFLAGS', ''))
-env.Replace(CCFLAGS = os.getenv('CCFLAGS', ''))
-env.Replace(CFLAGS = os.getenv('CFLAGS', ''))
-env.Replace(CXXFLAGS = os.getenv('CXXFLAGS', ''))
-env.Replace(LINKFLAGS = os.getenv('LDFLAGS', ''))
-env.Replace(LIBPATH = [os.getenv('LIBPATH', '')])
+env.Replace(CPPFLAGS  = os.getenv('CPPFLAGS', ''))
+env.Replace(CCFLAGS   = os.getenv('CCFLAGS',  opt_flags + compile_arch))
+env.Replace(CFLAGS    = os.getenv('CFLAGS',   ''))
+env.Replace(CXXFLAGS  = os.getenv('CXXFLAGS', ''))
+env.Replace(LINKFLAGS = os.getenv('LDFLAGS',  link_arch))
+env.Replace(LIBPATH   = [os.getenv('LIBPATH', '')])
+env.Replace(RPATH     = [os.getenv('RPATH',   '')])
 
 # Set -pthread flag explicitly to make sure that pthreads are
 # enabled on all platforms.
 env.Append(CCFLAGS = ' -pthread')
 
-# Freebsd ports are installed under /usr/local
+# FreeBSD ports are usually installed under /usr/local
 if sysname == 'freebsd' or sysname == 'sunos':
-    env.Append(LIBPATH  = ['/usr/local/lib'])
-    env.Append(CCFLAGS = ' -I/usr/local/include ')
+    env.Append(LIBPATH = ['/usr/local/lib'])
+    env.Append(CPPPATH = ['/usr/local/include'])
 if sysname == 'sunos':
    env.Replace(SHLINKFLAGS = '-shared ')
 
@@ -209,25 +215,24 @@
 
 # Common C/CXX flags
 # These should be kept minimal as they are appended after C/CXX specific flags
-env.Append(CCFLAGS = opt_flags + compile_arch +
-                      ' -Wall -Wextra -Wno-unused-parameter')
+env.Append(CCFLAGS = ' -fPIC -Wall -Wextra -Wno-unused-parameter')
 
 # C-specific flags
-env.Append(CFLAGS = ' -std=c99 -fno-strict-aliasing -pipe')
+env.Prepend(CFLAGS = '-std=c99 -fno-strict-aliasing -pipe ')
 
 # CXX-specific flags
 # Note: not all 3rd-party libs like '-Wold-style-cast -Weffc++'
 #       adding those after checks
-env.Append(CXXFLAGS = ' -Wno-long-long -Wno-deprecated -ansi')
+env.Prepend(CXXFLAGS = '-Wno-long-long -Wno-deprecated -ansi ')
 if sysname != 'sunos':
-    env.Append(CXXFLAGS = ' -pipe')
+    env.Prepend(CXXFLAGS = '-pipe ')
 
 
 # Linker flags
 # TODO: enable ' -Wl,--warn-common -Wl,--fatal-warnings' after warnings from
 # static linking have beed addressed
 #
-#env.Append(LINKFLAGS = ' -Wl,--warn-common -Wl,--fatal-warnings')
+#env.Prepend(LINKFLAGS = '-Wl,--warn-common -Wl,--fatal-warnings ')
 
 #
 # Check required headers and libraries (autoconf functionality)
@@ -374,10 +379,3 @@
                 return File(configuredLibPath)
         else:
             if not conf.CheckLibWithHeader(libs=[libName],
-                                           header=header,
-                                           language='CXX',
-                                           autoadd=autoadd):
-                print 'Error: library %s does not exist' % libName
-                Exit (1)
-            return [libName]
-

=== debian/changelog ===
percona-galera-3 (3.21-0ubuntu2) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 06 Feb 2018 17:55:02 +0000

percona-galera-3 (3.21-0ubuntu1) bionic; urgency=medium

  * New upstream release (LP: #1735691):
    - d/p/*: Refresh.
  * d/rules,control: Force use of gcc-6 for compilation, aligning
    with pxc-5.6.
  * d/copyright: Tidy duplicate License naming.
  * d/control: Drop BD on dh-systemd, version debhelper as needed.
  * d/control: Bumped Standards-Version to 4.1.1:
    - d/copyright: Use https in Format field.
  * d/control: Update Vcs field for Ubuntu.

 -- James Page <james.page@ubuntu.com>  Fri, 01 Dec 2017 12:22:53 +0000

=== debian/control ===
--- 
+++ 
@@ -7,16 +7,18 @@
            Alexey Bychko <alexey.bychko@percona.com>,
            Tomislav Plavcic <tomislav.plavcic@percona.com>
 Build-Depends: check,
-               debhelper (>= 9~),
-               dh-systemd (>= 1.5),
+               debhelper (>= 9.20160709~),
+               g++-6,
+               gcc-6,
+               libasio-dev,
                libboost-dev (>= 1.41),
                libboost-program-options-dev (>= 1.41),
                libssl-dev,
                scons (>= 2)
-Standards-Version: 3.9.6
+Standards-Version: 4.1.1
 Homepage: http://www.percona.com/software/percona-xtradb-cluster
-Vcs-Git: git://github.com/percona/galera.git
-Vcs-Browser: http://github.com/percona/galera.git
+Vcs-Browser: https://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/percona-galera-3
+Vcs-Git: git://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/percona-galera-3
 
 Package: percona-galera-3
 Architecture: any
@@ -30,8 +32,10 @@
           percona-xtradb-cluster-galera-3.x,
           percona-xtradb-cluster-garbd-2.x,
           percona-xtradb-cluster-garbd-3.x
-Provides: galera-3, percona-xtradb-cluster-galera-25
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Provides: galera-3,
+          percona-xtradb-cluster-galera-25
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Description: Galera replication framework for Percona XtraDB Cluster
  Galera is a fast synchronous multimaster wsrep provider (replication engine)
  for transactional databases and similar applications. For more information
@@ -42,8 +46,9 @@
 
 Package: percona-galera-arbitrator-3
 Architecture: any
-Conflicts: garbd-2, garbd2
-Breaks: galera-arbitrator-3, 
+Conflicts: garbd-2,
+           garbd2
+Breaks: galera-arbitrator-3,
         percona-xtradb-cluster-galera-2.x,
         percona-xtradb-cluster-garbd-2.x,
         percona-xtradb-cluster-garbd-3.x
@@ -52,7 +57,9 @@
           percona-xtradb-cluster-garbd-2.x,
           percona-xtradb-cluster-garbd-3.x
 Provides: galera-arbitrator-3
-Depends: netcat-openbsd, ${misc:Depends}, ${shlibs:Depends}
+Depends: netcat-openbsd,
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: Galera arbitrator daemon for Percona XtraDB Cluster
  Galera is a fast synchronous multimaster wsrep provider (replication engine)
  for transactional databases and similar applications. For more information
@@ -65,13 +72,15 @@
 Package: percona-galera-3-dbg
 Architecture: any
 Section: debug
-Depends: percona-galera-3 (= ${binary:Version}), ${misc:Depends}
+Depends: percona-galera-3 (= ${binary:Version}),
+         ${misc:Depends}
 Description: debugging symbols for percona-galera-3
  This package contains the debugging symbols for percona-galera-3.
 
 Package: percona-galera-arbitrator-3-dbg
 Architecture: any
 Section: debug
-Depends: percona-galera-arbitrator-3 (= ${binary:Version}), ${misc:Depends}
+Depends: percona-galera-arbitrator-3 (= ${binary:Version}),
+         ${misc:Depends}
 Description: debugging symbols for percona-galera-arbitrator-3
  This package contains the debugging symbols for percona-galera-arbitrator-3.

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,14 @@
 #!/usr/bin/make -f
 
 export DH_VERBOSE=1
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
+
+# NOTE(jamespage): Force use of gcc-6 as 7 is currently incompatible.
+USE_THIS_GCC_VERSION = -6
+
+export CC=$(DEB_HOST_GNU_TYPE)-gcc$(USE_THIS_GCC_VERSION)
+export CXX=$(DEB_HOST_GNU_TYPE)-g++$(USE_THIS_GCC_VERSION)
 
 # Parallel build support as adviced
 # at https://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
